var FireDownloadUnknownContent = {
  fireDownloadPref : null,

  init : function firedownload_init() {
    var useFireDownload = document.getElementById("useFireDownload");
    var prefService = Cc["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
    this.fireDownloadPref = prefService.getBranch("extensions.firedownload.");

    // Make sure this is an HTTP download
    if (dialog.mLauncher.source.scheme != "http") {
      useFireDownload.checked = false;
      useFireDownload.disabled = true;
    }
    else {
      useFireDownload.checked = this.fireDownloadPref.getBoolPref("enabled");
    }

    document.documentElement.setAttribute(
      'ondialogaccept',
      'if (FireDownloadUnknownContent.dialogAccepted()) { ' +
         document.documentElement.getAttribute('ondialogaccept') +
      '} else { return true; }'
    );
  },

  checkboxClicked : function(checkbox) {
    this.fireDownloadPref.setBoolPref("enabled", checkbox.checked);
  },

  dialogAccepted : function firedownload_dialogAccepted() {
    if (document.getElementById('useFireDownload').checked) {
      // Verify typed app path, if necessary.
      if (dialog.useOtherHandler) {
        var helperApp = dialog.helperAppChoice();
        if (!helperApp || !helperApp.executable ||
            !helperApp.executable.exists()) {
          // Show alert and try again.        
          var bundle = dialog.dialogElement("strings");                    
          var msg = bundle.getFormattedString("badApp", [dialog.dialogElement("otherHandler").path]);
          var svc = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
          svc.alert(dialog.mDialog, bundle.getString("badApp.title"), msg);

          // Disable the OK button.
          dialog.mDialog.document.documentElement.getButton("accept").disabled = true;
          dialog.dialogElement("mode").focus();          

          // Clear chosen application.
          dialog.chosenApp = null;

          // Leave dialog up.
          return false;
        }
      }

      var needUpdate = dialog.updateMIMEInfo();

      var download = Cc["@mozilla.org/firedownload;1"].createInstance(Ci.nsIFireDownload);
      download.startWithLauncher(dialog.mLauncher, !document.getElementById('save').selected);

      if (needUpdate && dialog.mLauncher.MIMEInfo.MIMEType != "application/octet-stream")
        dialog.updateHelperAppPref();
        
      // Null out the dialog member since we don't want the download to cancel until we're sure we can handle it
      dialog.mDialog.dialog = null;

      return false;
    }

    return true;
  }
};

window.addEventListener("load", function() { FireDownloadUnknownContent.init(); }, false); 
